
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Title_castDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const title_cast = await db.title_cast.create(
            {
                id: data.id || undefined,
        
        character_name: data.character_name
        ||
        null
            ,
            
        billing_order: data.billing_order
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await title_cast.setTitle( data.title || null, {
            transaction,
        });
        
        await title_cast.setPerson( data.person || null, {
            transaction,
        });
        

        

        

        return title_cast;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const title_castData = data.map((item, index) => ({
                id: item.id || undefined,
                
                character_name: item.character_name
            ||
            null
            ,
            
                billing_order: item.billing_order
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const title_cast = await db.title_cast.bulkCreate(title_castData, { transaction });

        // For each item created, replace relation files
        

        return title_cast;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const title_cast = await db.title_cast.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.character_name !== undefined) updatePayload.character_name = data.character_name;
        
        
        if (data.billing_order !== undefined) updatePayload.billing_order = data.billing_order;
        
        
        updatePayload.updatedById = currentUser.id;

        await title_cast.update(updatePayload, {transaction});

        
        
        if (data.title !== undefined) {
            await title_cast.setTitle(
              
              data.title,
              
              { transaction }
            );
        }
        
        if (data.person !== undefined) {
            await title_cast.setPerson(
              
              data.person,
              
              { transaction }
            );
        }
        

        
        

        

        return title_cast;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const title_cast = await db.title_cast.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of title_cast) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of title_cast) {
                await record.destroy({transaction});
            }
        });


        return title_cast;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const title_cast = await db.title_cast.findByPk(id, options);

        await title_cast.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await title_cast.destroy({
            transaction
        });

        return title_cast;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const title_cast = await db.title_cast.findOne(
            { where },
            { transaction },
        );

        if (!title_cast) {
            return title_cast;
        }

        const output = title_cast.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.title = await title_cast.getTitle({
            transaction
        });
        
        
        output.person = await title_cast.getPerson({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.titles,
        as: 'title',
        
        where: filter.title ? {
          [Op.or]: [
            { id: { [Op.in]: filter.title.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.title.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.people,
        as: 'person',
        
        where: filter.person ? {
          [Op.or]: [
            { id: { [Op.in]: filter.person.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.person.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.character_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'title_cast',
                        'character_name',
                        filter.character_name,
                    ),
                };
            }
            

            
            

            
            if (filter.billing_orderRange) {
                const [start, end] = filter.billing_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    billing_order: {
                    ...where.billing_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    billing_order: {
                    ...where.billing_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.title_cast.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'title_cast',
                        'character_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.title_cast.findAll({
            attributes: [ 'id', 'character_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['character_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.character_name,
        }));
    }

    
};

